/* Modified by Scott Hall shall@shall.dhs.org Original - dentar@dentar.com
   25/10/1999 - made speech only say user defined message not whole line in log
   25/10/1999 - added sleep(3) to for loop to stop excessive CPU usage (96%!!)
   26/10/1999 - moved strcat(chmodcmd,"chmod 666 "); and
              strcat(chmodcmd,ttyfilename); to after valid tty checks to stop
	      core dumps.
   26/10/1999 - added -P for speech (whole line)
   26/10/1999 - added -S for sleep time specification
   27/10/1999 - fixed some small problems with speech support - Dale
Chesser (squatex@nettaxi.com)
   27/10/1999 - changed "=" to "==" on if (speech=3) line - dentar
   17/09/2009 - awkwardly added -a and -A (copies -p -P). uses
festival instead of speechd
*/

#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main(argc, argv, envp)
	int argc;
	char **argv[];
	char **envp[];
{
	time_t curtime=0;
	int stringlen=0;
	int sleepytime=3;
	int daemonize=0;
	int forky=0;
	int help=0;
	int wholeline=0;
	int speech=0;
	int festy=0;
	int debug=0;
	int freq=750;
	int duration=250;
	FILE *filehan=NULL;
	FILE *ttyout=NULL;
	FILE *logfile=NULL;
	FILE *speechfile=NULL;
	char *comand=NULL;
	char *iam=NULL;
	char *spaces=NULL;
	char *VERSTRING="0.46";
	char *logfilename=NULL;
	char *filename=NULL;
	char *ttyfilename=NULL;
	char *string=NULL;
	char *messagesay=NULL;
	char *inputstring=NULL;
	char *chmodcmd=NULL;
	char argy=(char)0;

	iam=calloc(1,256);
	strcpy(iam,(char *)argv[0]);

	spaces=malloc(256);
	memset(spaces,32,256);

	inputstring=(char *)calloc(1,4096);

	chmodcmd=(char *)calloc(1,256);
	
	do
	{
		/* : means get after input parameter */
		argy = getopt(argc,(char **)argv,"h?Ddl:wt:f:s:S:x:p:PVF:a:AVF:M:");

		switch (argy)
		{
			case 'h':	help=1;
					break;
			case '?':	help=1;
					break;
			case 'D':	debug=1;
					break;
			case 'd':	daemonize=1;
					break;
			case 'l':	logfilename=(char *)calloc(1,1024);
					strcpy(logfilename,optarg);
					break;
			case 'w':	wholeline=1;
					break;
			case 't':	ttyfilename=(char *)calloc(1,1024);
					strcpy(ttyfilename,optarg);
					break;
			case 'f':	filename=(char *)calloc(1,1024);
					strcpy(filename,optarg);
					break;
			case 's':	string=(char *)calloc(1,1024);
					strcpy(string,optarg);
					stringlen=strlen(string);
					break;
			case 'x':	comand=(char *)calloc(1,1024);
					strcpy(comand,optarg);
					break;
			case 'S':	sleepytime=atoi(optarg);
					break;
			case 'p':	if (speech==0) speech=1;
					else if(speech==2)
						speech=3;
					else
						printf ("ignoring -p\n");
					/* added to capture user defined message */
					messagesay=(char *)calloc(1,1024);
					strcpy(messagesay,optarg);
					break;
			case 'P':
					if (speech==0)
						speech=2;
					else if(speech==1)
						speech=3;
					else
						printf ("ignoring -P\n");
					break;
			case 'a':	
					if (festy==0) festy=1;
					else if(festy==2)
						festy=3;
					else
						printf ("ignoring -a\n");
					/* added to capture user defined message */
					messagesay=(char *)calloc(1,1024);
					strcpy(messagesay,optarg);
					break;
			case 'A':	
					if (festy==0)
						festy=2;
					else if(festy==1)
						festy=3;
					else
						printf ("ignoring -A\n");
					break;

			case 'V':
					printf("\ntailbeep %s\n",VERSTRING);
					printf("by Tommy, dentar@dentar.com\n");
					printf("Modified Dale Chesser, Scott Hall, and Superkuh\n");
					exit (0);
			case 'M':	duration=atoi(optarg);
					break;
			case 'F':	freq=atoi(optarg);
					break;
			
			default:	;
		}
		
	} while (argy != EOF);

	if (help==1)
	{
		printf("\n");
		printf("Usage: %s -f (filename) -t (tty) -s (string)\n",iam);
		fwrite(spaces,1,8+strlen(iam),stdout);
		printf("[-l (filename) [-w]] [-P ] [-p \"(message)\"]\n");
		fwrite(spaces,1,8+strlen(iam),stdout);
		printf("[-S sleep] [-d] [-D]\n");
		fwrite(spaces,1,8+strlen(iam),stdout);
		printf("[-F freq ] [-M millisec] [-V]\n");
		fwrite(spaces,1,7,stdout);
		printf("%s [-?|-h]\n",iam);
		printf("\n");
		printf("* -f filename   filename is the file to watch\n");
		printf("* -t /dev/ttyxx tty to send the beeps to\n");
		printf("* -s string     string to watch for in filename\n");
		printf("  -l filename   append to log file\n");
		printf("  -w            show whole line in log file (-l required)\n");
		printf("  -P            speak found lines via /dev/speech (requires speechd)\n");
		printf("  -p \"message\"  speak \"message\" via /dev/speech (requires speechd)\n");
		printf("  -A            speak found lines via /dev/speech (requires festival)\n");
		printf("  -a \"message\"  speak \"message\" via /dev/speech (requires festival)\n");
		printf("  -S integer    sleep for integer seconds between checks\n");
		printf("  -x \"cmds...\"  cmds to execute (via system call) (dangerous)\n");
		printf("  -d            daemonize\n");
		printf("  -D            Debug mode\n");
		printf("  -F freq       Frequency of beep in hertz\n");
		printf("  -M ms         Duration of beep in milliseconds\n");
		printf("  -V            Version information\n");
		printf("(note: * = required)\n");
		printf("\n");
		exit(0);
	}

	if (daemonize==1)
	{
		forky=fork();

		if (forky>0) {
			printf ("Forked!\n");
			exit(0);
		}
		else if (forky<0)
		{
			fprintf (stderr,"tailbeep: fork failed.\n");
			fflush(stderr);
			exit(1);
		}
	}
	
	if ((filename==NULL) || (string==NULL) || (ttyfilename==NULL))
	{
		fprintf (stderr,"tailbeep: You MUST specify options -t, -f and -s with parameters!\n          (Parameters are also required for the optional flags -l & -p)\n");
		fflush(stderr);
		exit(1);
	}

	strcat(chmodcmd,"chmod 666 "); /* moved to after valid tty check */
	strcat(chmodcmd,ttyfilename);  /* moved to after valid tty check */

	if ((filehan=fopen(filename,"r"))==NULL)
	{
		fprintf (stderr,"tailbeep, file: Can't open %s!\n",filename);
		fflush(stderr);
		exit(2);
	}

	if ((fseek(filehan,0L,SEEK_END))!=0)
	{
		fprintf (stderr,"tailbeep: Can't seek to end of file %s!\n",filename);
		fflush(stderr);
		exit(2);
	}

	if ((ttyout=fopen(ttyfilename,"a+"))==NULL)
	{
		fprintf (stderr,"tailbeep, tty: Can't open %s!\n",ttyfilename);
		fflush(stderr);
		exit(2);
	}

	if (speech>0)
	{
		if (debug==1) fprintf(stderr,"Opening speech...\n"); fflush(stderr);
		speechfile=fopen("/dev/speech","w");
		if (debug==1) fprintf(stderr,"speechfile is %p\n",speechfile);
		if(speechfile==NULL)
		{
			fprintf(stderr,"tailbeep: Can't open /dev/speech!  Did you install speechd?");
			fflush(stderr);
			fclose(speechfile);
			speech=0;
		}

		if (debug==1) fprintf(stderr,"Done opening speech...\n"); fflush(stderr);
	}

	if (debug==1) fprintf(stderr,"Listening...\n");
	fflush(stderr);

	if (logfilename!=NULL)
	{
		if ((logfile=fopen(logfilename,"a+"))!=(FILE *)NULL)
		{
			fprintf(logfile,"Program started...\n");
			fflush(logfile);
		} else
		{
			fprintf (stderr,"tailbeep: Can't open log file %s\n",logfilename);
			exit (1);
		}
	} else {
		if (wholeline==1)
			fprintf (stderr,"tailbeep: Ignoring -w because -l not specified.\n");
	}
	
	for (;;)
	{
		memset(inputstring,0,4096);
		fgets(inputstring,1024,filehan);
		if (strstr(inputstring,string)!=NULL)
		{
			curtime=time(NULL);
			if (logfilename!=(char *)NULL)
			{
				if (wholeline==1)
				{
					fprintf(logfile,"%s -> %s",
					inputstring, ctime(&curtime));
				} else {
					fprintf(logfile,"Saw \"%s\" in %s at %s",
					string, filename, ctime(&curtime));
				}
				fflush(logfile);
			}

			if (debug==1) fprintf(stderr,"Saw \"%s\" in %s at %s",
					string, filename, ctime(&curtime));
			fflush(stderr);
			if (debug==1) fprintf(ttyout,"Saw \"%s\" in %s at %s",
					string, filename, ctime(&curtime));
			if (festy==0)
			{	/* don't beep if festival speech is enabled */
				fprintf(ttyout,"%c[10;%d]%c[11;%d]\a",27,freq,27,duration);
				fflush(ttyout);
			}

			if (speech==1)
			{
				/* changed fprintf(speechfile,"%s",inputstring);
				to fprintf(speechfile,messagesay);
				to stop whole log entry being read out now user
				defined "message" is said by speech */
				fprintf(speechfile,"%s\n",messagesay);
				fflush(speechfile);
			}

			if(speech==2)
			{
				fprintf(speechfile,"%s\n",inputstring);
				fflush(speechfile);
			}
			
			if(speech==3)
			{
				fprintf(speechfile,"%s %s\n",messagesay,inputstring);
				fflush(speechfile);
			}


			if (festy==1)
			{
				char temp[1024];
				sprintf(temp, "echo %s | festival --tts", messagesay);
				system((char *)temp);	
			}

			if(festy==2)
			{
				char temp[1024];
				sprintf(temp, "echo %s | festival --tts", inputstring);
				system((char *)temp);	
			}
			
			if(festy==3)
			{
				char temp[1024];
				sprintf(temp, "echo %s %s |festival --tts", messagesay, inputstring);
				system((char *)temp);	
			}



			if(comand!=(char *)NULL)
			{
				system(comand);
			}
		}
	sleep(sleepytime); /* added to stop excessive CPU usage */
	}
}
